# labcom-client initialization script (csh)

set LABCOM_DIR=

if ( -d "$LABCOM_DIR" ) then

switch (`uname -m`)
	case x86_64:
		set BIN = "$LABCOM_DIR/bin64"
		breaksw
	case *:
		set BIN = "$LABCOM_DIR/bin"
endsw

if ( "${path}" !~ *$BIN* ) then
	set path = ( $BIN $path )
endif

setenv Retrieve $LABCOM_DIR
setenv INDEXSERVERNAME "DasIndex.LHD.nifs.ac.jp/lhd"

unset LABCOM_DIR BIN

endif
