function dbstoreVersion( )
% Display the version of dbstore.
%   dbstoreVersion
%
% Examples :
%   >> dbstoreVersion
%
% Last update : 2012-05-11
%
% See also
%      dbsOpen dbsWrite dbsClose dbsAbort dbsMessage
%      dbsOpenFrame dbsWriteFrame dbsWriteFrames dbsCloseFrame dbstore.txt

liblabcom = 'libdbstore';
if ~loadLibLabcom( liblabcom, true )
    return;
end
%
ver_d = calllib( liblabcom, 'dbsVersion');
ver_z = calllib( liblabcom, 'dbsZversion');
fprintf('%s zlib:%s\n', ver_d, ver_z );
end